package lectura_ficheros;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.lang.String;
import java.util.StringTokenizer;

import javax.swing.JFrame;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

enum TipoLinea {objeto_de_estudio, texto_irrelevante, unidades, cabecera, cuerpo, error}

public class FicheroTabular {
	
	public ContenidoFichero contenido;
	public int numMuestras;
	public int numAtribs;
	public float min;
	public float max;
	
	String fichero;
	char separador;
	int num_linea_objeto_de_estudio;
	int num_linea_unidades;
	int num_linea_fecha;
	
	public FicheroTabular (){
		fichero = null;
		separador = '\t';
		num_linea_objeto_de_estudio = num_linea_unidades =	num_linea_fecha = 0;
	}
	
	public FicheroTabular (String afichero, int anum_linea_objeto_de_estudio, int anum_linea_unidades, int anum_linea_fecha){
		fichero = afichero;
		separador = '\t';
		num_linea_objeto_de_estudio = anum_linea_objeto_de_estudio;
		num_linea_unidades = anum_linea_unidades;
		num_linea_fecha = anum_linea_fecha;
	}
	
	public FicheroTabular (String afichero, char aseparador, int anum_linea_objeto_de_estudio, int anum_linea_unidades, int anum_linea_fecha){
		fichero = afichero;
		separador = aseparador;
		num_linea_objeto_de_estudio = anum_linea_objeto_de_estudio;
		num_linea_unidades = anum_linea_unidades;
		num_linea_fecha = anum_linea_fecha;
	}
	
	void leerMetadatosdeFTabular() throws IOException{

		FileReader fr = null;
		BufferedReader entrada = null;
		String linea_aux=null, obj_estudio=null, unids=null, data=null;
		
		try {
			fr = new FileReader(fichero);
			entrada = new BufferedReader(fr);
			TipoLinea tipo_linea;
			int cont = 0;
			int maximo = seleccionaMaximoDe3(num_linea_objeto_de_estudio, num_linea_unidades, num_linea_fecha);
			
			//bucle donde organizaremos los metadatos de las tablas
			//objeto de estudio, unidades y fecha
			do {
				cont++;
				linea_aux = entrada.readLine();
				//TODO tratar las lineas
				if (cont == num_linea_objeto_de_estudio){
					//TODO ver si hay mas de una
					obj_estudio = tratarLineaOE(linea_aux);
				}
				
				if (cont == num_linea_unidades){
					unids = tratarLineaUds(linea_aux);
				}
				
				if (cont == num_linea_fecha){
					//TODO ver si hay mas de una
					data = tratarLineaFecha(linea_aux);
				}
				
			} while ((linea_aux != null) && (cont != maximo));
			
			//TODO introducir "lugar"
//	        SwingUtilities.invokeLater(new Runnable() {
//	            public void run() {PanelOpciones po = new PanelOpciones(obj_estudio,unids,data,data);
//	                //Turn off metal's use of bold fonts
//	                UIManager.put("swing.boldMetal", Boolean.FALSE); 
//	                po.createAndShowGUI();
//	            }
//	        });
			PanelOpciones po= new PanelOpciones("Modificacion de datos", obj_estudio,unids,data,data);
			
		}finally{
			try{                    
				if( null != fr ){   
					fr.close();     
				}                  
			}catch (Exception e2){ 
				e2.printStackTrace();
			}
		}
	}
	
	
	private String tratarLineaFecha(String linea_aux) {
		// TODO Auto-generated method stub
		return null;
	}

	private String tratarLineaUds(String linea_aux) {
		// TODO Auto-generated method stub
		return null;
	}

	private String tratarLineaOE(String linea_aux) {
		// TODO Auto-generated method stub
		StringTokenizer st = new StringTokenizer(linea_aux, '\t');
		
		return null;
	}

	private int seleccionaMaximoDe3(int uno, int dos, int tres) {
		int vmax = uno;
		if (dos > vmax)
			vmax = dos;
		if (tres > vmax)
			vmax = tres;
		return vmax;
	}


	//lee las primeras lineas del fichero y las clasifica para extraer 
	//la metainformacion de los datos.
	//despues rescata la tabla en una estructura ContenidoFichero
	//y despues de eso ignora el resto del fichero
	void leerDatosdeFTabular(String fichero, char separador, int linea_objeto_de_estudio, int linea_unidades, int fecha) throws IOException{

		FileReader fr = null;
		BufferedReader entrada = null;
		
		try {
			fr = new FileReader(fichero);
			entrada = new BufferedReader(fr);
			String linea_aux;
			TipoLinea tipo_linea;
			
			//bucle donde organizaremos los metadatos de las tablas
			//hasta conocer los atributos de estudio
			do {
				linea_aux = entrada.readLine();
				tipo_linea = analizar_linea(linea_aux);
				
				switch (tipo_linea){
				case texto_irrelevante: 
					break;
				case objeto_de_estudio:
					contenido.objeto_de_estudio = linea_aux;
					break;
				case unidades:
					contenido.unidades = linea_aux;
					break;
				case cabecera:
					contenido.rellenar_cabecera(linea_aux);
					break;
				case cuerpo:
					contenido.rellenar_tabla(linea_aux, entrada);
					break;
				default:
					break;
				}
			} while (linea_aux != null);
			
		}finally{
			try{                    
				if( null != fr ){   
					fr.close();     
				}                  
			}catch (Exception e2){ 
				e2.printStackTrace();
			}
		}
	}

	private TipoLinea analizar_linea(String linea) {
		// TODO Auto-generated method stub
		//TODO ver si hay linea de TOTAL TOTAL....
		return null;
	}
}

